Index: palm/trunk/SOURCE/surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_mod.f90	(revision 4501)
+++ palm/trunk/SOURCE/surface_mod.f90	(revision 4502)
@@ -2162,7 +2217,7 @@
 !
 !--                Upward-facing surface. Distinguish between differet surface types.
-!--                To do, think about method to flag natural and non-natural 
-!--                surfaces. 
-                   IF ( .NOT. BTEST( wall_flags_total_0(k-1,j,i), 0 ) )  THEN 
+!--                To do, think about method to flag natural and non-natural
+!--                surfaces.
+                   IF ( .NOT. BTEST( wall_flags_total_0(k-1,j,i), 0 ) )  THEN
 !
 !--                   Determine flags indicating terrain or building
@@ -2171,7 +2226,7 @@
                       building = BTEST( wall_flags_total_0(k-1,j,i), 6 )  .OR.       &
                                  topo_no_distinct
-                                 
-!
-!--                   unresolved_building indicates a surface with equal height 
+
+!
+!--                   unresolved_building indicates a surface with equal height
 !--                   as terrain but with a non-grid resolved building on top.
 !--                   These surfaces will be flagged as urban surfaces.
@@ -2179,5 +2234,5 @@
                                      .AND.  BTEST( wall_flags_total_0(k-1,j,i), 6 )
 !
-!--                   Natural surface type          
+!--                   Natural surface type
                       IF ( land_surface  .AND.  terrain  .AND.                 &
                            .NOT. unresolved_building )  THEN
@@ -2186,5 +2241,5 @@
                                                               num_lsm_h,       &
                                                               num_lsm_h_kji,   &
-                                                              .TRUE., .FALSE. )  
+                                                              .TRUE., .FALSE. )
 !
 !--                   Urban surface tpye
@@ -2194,5 +2249,5 @@
                                                               num_usm_h,       &
                                                               num_usm_h_kji,   &
-                                                              .TRUE., .FALSE. )  
+                                                              .TRUE., .FALSE. )
 !
 !--                   Default surface type
@@ -2202,10 +2257,10 @@
                                                               num_def_h(0),    &
                                                               num_def_h_kji(0),&
-                                                              .TRUE., .FALSE. )  
+                                                              .TRUE., .FALSE. )
                       ENDIF
-                   ENDIF  
-!
-!--                downward-facing surface, first, model top. Please note, 
-!--                for the moment, downward-facing surfaces are always of 
+                   ENDIF
+!
+!--                downward-facing surface, first, model top. Please note,
+!--                for the moment, downward-facing surfaces are always of
 !--                default type
                    IF ( k == nzt  .AND.  use_top_fluxes )  THEN
@@ -2213,5 +2268,5 @@
                                            num_def_h(2), num_def_h_kji(2) )
 !
-!--                Check for any other downward-facing surface. So far only for 
+!--                Check for any other downward-facing surface. So far only for
 !--                default surface type.
                    ELSEIF ( .NOT. BTEST( wall_flags_total_0(k+1,j,i), 0 ) )  THEN
@@ -2220,6 +2275,6 @@
                                                            num_def_h(1),       &
                                                            num_def_h_kji(1),   &
-                                                           .FALSE., .TRUE. )    
-                   ENDIF 
+                                                           .FALSE., .TRUE. )
+                   ENDIF
 !
 !--                Check for vertical walls and, if required, initialize it.
@@ -2235,5 +2290,5 @@
                       unresolved_building = BTEST( wall_flags_total_0(k,j-1,i), 5 )  &
                                      .AND.  BTEST( wall_flags_total_0(k,j-1,i), 6 )
-                                     
+
                       IF ( land_surface  .AND.  terrain  .AND.                 &
                            .NOT. unresolved_building )  THEN
@@ -2242,5 +2297,5 @@
                                                             num_lsm_v(0),      &
                                                             num_lsm_v_kji(0),  &
-                                                            .FALSE., .FALSE.,  &             
+                                                            .FALSE., .FALSE.,  &
                                                             .FALSE., .TRUE. )
                       ELSEIF ( urban_surface  .AND.  building )  THEN
@@ -2249,5 +2304,5 @@
                                                             num_usm_v(0),      &
                                                             num_usm_v_kji(0),  &
-                                                            .FALSE., .FALSE.,  &             
+                                                            .FALSE., .FALSE.,  &
                                                             .FALSE., .TRUE. )
                       ELSE
@@ -2256,6 +2311,6 @@
                                                             num_def_v(0),      &
                                                             num_def_v_kji(0),  &
-                                                            .FALSE., .FALSE.,  &             
-                                                            .FALSE., .TRUE. ) 
+                                                            .FALSE., .FALSE.,  &
+                                                            .FALSE., .TRUE. )
                       ENDIF
                    ENDIF
@@ -2269,8 +2324,8 @@
                       building = BTEST( wall_flags_total_0(k,j+1,i), 6 )  .OR.       &
                                  topo_no_distinct
-                                 
+
                       unresolved_building = BTEST( wall_flags_total_0(k,j+1,i), 5 )  &
                                      .AND.  BTEST( wall_flags_total_0(k,j+1,i), 6 )
-                                     
+
                       IF ( land_surface  .AND.  terrain  .AND.                 &
                            .NOT. unresolved_building )  THEN
@@ -2294,5 +2349,5 @@
                                                             num_def_v_kji(1),  &
                                                             .FALSE., .FALSE.,  &
-                                                            .TRUE., .FALSE. ) 
+                                                            .TRUE., .FALSE. )
                       ENDIF
                    ENDIF
@@ -2306,8 +2361,8 @@
                       building = BTEST( wall_flags_total_0(k,j,i-1), 6 )  .OR.       &
                                  topo_no_distinct
-                                 
+
                       unresolved_building = BTEST( wall_flags_total_0(k,j,i-1), 5 )  &
                                      .AND.  BTEST( wall_flags_total_0(k,j,i-1), 6 )
-                                 
+
                       IF ( land_surface  .AND.  terrain  .AND.                 &
                            .NOT. unresolved_building )  THEN
@@ -2331,8 +2386,8 @@
                                                             num_def_v_kji(2),  &
                                                             .TRUE., .FALSE.,   &
-                                                            .FALSE., .FALSE. ) 
+                                                            .FALSE., .FALSE. )
                       ENDIF
-                   ENDIF 
-!   
+                   ENDIF
+!
 !--                westward-facing surface
                    IF ( .NOT. BTEST( wall_flags_total_0(k,j,i+1), 0 ) )  THEN
@@ -2343,8 +2398,8 @@
                       building = BTEST( wall_flags_total_0(k,j,i+1), 6 )  .OR.       &
                                  topo_no_distinct
-                                 
+
                       unresolved_building = BTEST( wall_flags_total_0(k,j,i+1), 5 )  &
                                      .AND.  BTEST( wall_flags_total_0(k,j,i+1), 6 )
-                                  
+
                       IF ( land_surface  .AND.  terrain  .AND.                 &
                            .NOT. unresolved_building )  THEN
@@ -2368,14 +2423,14 @@
                                                             num_def_v_kji(3),  &
                                                            .FALSE., .TRUE.,    &
-                                                           .FALSE., .FALSE. ) 
+                                                           .FALSE., .FALSE. )
                       ENDIF
                    ENDIF
                 ENDIF
 
- 
+
              ENDDO
 !
-!--          Determine start- and end-index at grid point (j,i). Also, for 
-!--          horizontal surfaces more than 1 horizontal surface element can 
+!--          Determine start- and end-index at grid point (j,i). Also, for
+!--          horizontal surfaces more than 1 horizontal surface element can
 !--          exist at grid point (j,i) if overhanging structures are present.
 !--          Upward-facing surfaces
@@ -2393,5 +2448,5 @@
 !
 !--          Downward-facing surfaces, except model top
-             surf_def_h(1)%start_index(j,i) = start_index_def_h(1)                                                 
+             surf_def_h(1)%start_index(j,i) = start_index_def_h(1)
              surf_def_h(1)%end_index(j,i)   = surf_def_h(1)%start_index(j,i) + &
                                                  num_def_h_kji(1) - 1
@@ -2399,5 +2454,5 @@
 !
 !--          Downward-facing surfaces -- model top fluxes
-             surf_def_h(2)%start_index(j,i) = start_index_def_h(2)                                                 
+             surf_def_h(2)%start_index(j,i) = start_index_def_h(2)
              surf_def_h(2)%end_index(j,i)   = surf_def_h(2)%start_index(j,i) + &
                                                  num_def_h_kji(2) - 1
@@ -2422,5 +2477,5 @@
              surf_def_v(2)%start_index(j,i) = start_index_def_v(2)
              surf_def_v(3)%start_index(j,i) = start_index_def_v(3)
-             surf_def_v(0)%end_index(j,i)   = start_index_def_v(0) +           & 
+             surf_def_v(0)%end_index(j,i)   = start_index_def_v(0) +           &
                                               num_def_v_kji(0) - 1
              surf_def_v(1)%end_index(j,i)   = start_index_def_v(1) +           &
@@ -2440,5 +2495,5 @@
              surf_lsm_v(2)%start_index(j,i) = start_index_lsm_v(2)
              surf_lsm_v(3)%start_index(j,i) = start_index_lsm_v(3)
-             surf_lsm_v(0)%end_index(j,i)   = start_index_lsm_v(0) +           & 
+             surf_lsm_v(0)%end_index(j,i)   = start_index_lsm_v(0) +           &
                                               num_lsm_v_kji(0) - 1
              surf_lsm_v(1)%end_index(j,i)   = start_index_lsm_v(1) +           &
@@ -2458,5 +2513,5 @@
              surf_usm_v(2)%start_index(j,i) = start_index_usm_v(2)
              surf_usm_v(3)%start_index(j,i) = start_index_usm_v(3)
-             surf_usm_v(0)%end_index(j,i)   = start_index_usm_v(0) +           & 
+             surf_usm_v(0)%end_index(j,i)   = start_index_usm_v(0) +           &
                                               num_usm_v_kji(0) - 1
              surf_usm_v(1)%end_index(j,i)   = start_index_usm_v(1) +           &
@@ -2480,13 +2535,13 @@
 ! Description:
 ! ------------
-!> Initialize horizontal surface elements, upward- and downward-facing. 
+!> Initialize horizontal surface elements, upward- and downward-facing.
 !> Note, horizontal surface type alsw comprises model-top fluxes, which are,
-!> initialized in a different routine. 
+!> initialized in a different routine.
 !------------------------------------------------------------------------------!
           SUBROUTINE initialize_horizontal_surfaces( k, j, i, surf, num_h,     &
                                                      num_h_kji, upward_facing, &
-                                                     downward_facing )       
-
-             IMPLICIT NONE 
+                                                     downward_facing )
+
+             IMPLICIT NONE
 
              INTEGER(iwp)  ::  i                !< running index x-direction
@@ -2509,5 +2564,5 @@
              surf%k(num_h) = k
 !
-!--          Surface orientation, bit 0 is set to 1 for upward-facing surfaces, 
+!--          Surface orientation, bit 0 is set to 1 for upward-facing surfaces,
 !--          bit 1 is for downward-facing surfaces.
              IF ( upward_facing   )  surf%facing(num_h) = IBSET( surf%facing(num_h), 0 )
@@ -2520,8 +2575,8 @@
                 surf%z_mo(num_h)  = zw(k) - zu(k)
              ENDIF
- 
+
              surf%z0(num_h)    = roughness_length
              surf%z0h(num_h)   = z0h_factor * roughness_length
-             surf%z0q(num_h)   = z0h_factor * roughness_length          
+             surf%z0q(num_h)   = z0h_factor * roughness_length
 !
 !--          Initialization in case of 1D pre-cursor run
@@ -2553,19 +2608,19 @@
                 surf%ol(num_h)   = surf%z_mo(num_h) / zeta_min
 !
-!--             Very small number is required for calculation of Obukhov length 
-!--             at first timestep     
-                surf%us(num_h)    = 1E-30_wp 
+!--             Very small number is required for calculation of Obukhov length
+!--             at first timestep
+                surf%us(num_h)    = 1E-30_wp
                 surf%usws(num_h)  = 0.0_wp
                 surf%vsws(num_h)  = 0.0_wp
-        
-             ENDIF
-
-             surf%rib(num_h)     = 0.0_wp 
+
+             ENDIF
+
+             surf%rib(num_h)     = 0.0_wp
              surf%uvw_abs(num_h) = 0.0_wp
 
-             IF ( .NOT. constant_diffusion )  THEN    
-                surf%u_0(num_h)     = 0.0_wp  
+             IF ( .NOT. constant_diffusion )  THEN
+                surf%u_0(num_h)     = 0.0_wp
                 surf%v_0(num_h)     = 0.0_wp
-             ENDIF 
+             ENDIF
 
              surf%ts(num_h)   = 0.0_wp
@@ -2573,5 +2628,5 @@
 !--          Set initial value for surface temperature
              surf%pt_surface(num_h) = pt_surface
-             
+
              IF ( humidity )  THEN
                 surf%qs(num_h)   = 0.0_wp
@@ -2579,5 +2634,5 @@
                    surf%qcs(num_h) = 0.0_wp
                    surf%ncs(num_h) = 0.0_wp
-   
+
                    surf%qcsws(num_h) = 0.0_wp
                    surf%ncsws(num_h) = 0.0_wp
@@ -2587,5 +2642,5 @@
                    surf%qrs(num_h) = 0.0_wp
                    surf%nrs(num_h) = 0.0_wp
-   
+
                    surf%qrsws(num_h) = 0.0_wp
                    surf%nrsws(num_h) = 0.0_wp
@@ -2594,7 +2649,16 @@
                    surf%qv1(num_h)  = 0.0_wp
                    surf%vpt1(num_h) = 0.0_wp
-                   
+
                 ENDIF
-                
+
+                IF ( surf_bulk_cloud_model .AND. surf_microphysics_ice_extension)  THEN
+                   surf%qis(num_h) = 0.0_wp
+                   surf%nis(num_h) = 0.0_wp
+
+                   surf%qisws(num_h) = 0.0_wp
+                   surf%nisws(num_h) = 0.0_wp
+                ENDIF
+
+
                 surf%q_surface(num_h)   = q_surface
                 surf%vpt_surface(num_h) = surf%pt_surface(num_h) *             &
@@ -2607,5 +2671,5 @@
                 IF ( air_chemistry )  surf%css(lsp,num_h)   = 0.0_wp
 !
-!--             Ensure that fluxes of compounds which are not specified in 
+!--             Ensure that fluxes of compounds which are not specified in
 !--             namelist are all zero --> kanani: revise
                 IF ( air_chemistry )  surf%cssws(lsp,num_h) = 0.0_wp
@@ -2618,6 +2682,6 @@
                 IF ( upward_facing )  THEN
                    IF ( constant_heatflux )  THEN
-!   
-!--                   Initialize surface heatflux. However, skip this for now if 
+!
+!--                   Initialize surface heatflux. However, skip this for now if
 !--                   if random_heatflux is set. This case, shf is initialized later.
                       IF ( .NOT. random_heatflux )  THEN
@@ -2625,5 +2689,5 @@
                                                  heatflux_input_conversion(k-1)
 !
-!--                      Check if surface heat flux might be replaced by 
+!--                      Check if surface heat flux might be replaced by
 !--                      prescribed wall heatflux
                          IF ( k-1 /= 0 )  THEN
@@ -2683,5 +2747,5 @@
 !
 !--                      Assign surface flux for each variable species
-                         IF ( TRIM( spc_names(lsp) ) == TRIM( surface_csflux_name(lsp_pr) ) )  THEN   
+                         IF ( TRIM( spc_names(lsp) ) == TRIM( surface_csflux_name(lsp_pr) ) )  THEN
                             IF ( upward_facing )  THEN
                                IF ( constant_csflux(lsp_pr) )  THEN
@@ -2693,5 +2757,5 @@
                                      surf%cssws(lsp,num_h) =                   &
                                                        wall_csflux(lsp,0) *    &
-                                                       rho_air_zw(k-1) 
+                                                       rho_air_zw(k-1)
                                ELSE
                                   surf%cssws(lsp,num_h) = 0.0_wp
@@ -2708,5 +2772,5 @@
 
                 IF ( ocean_mode )  THEN
-                   IF ( upward_facing )  THEN 
+                   IF ( upward_facing )  THEN
                       surf%sasws(num_h) = bottom_salinityflux * rho_air_zw(k-1)
                    ELSE
@@ -2718,19 +2782,19 @@
 !--          Increment surface indices
              num_h     = num_h + 1
-             num_h_kji = num_h_kji + 1      
+             num_h_kji = num_h_kji + 1
 
 
           END SUBROUTINE initialize_horizontal_surfaces
-       
+
 
 !------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Initialize model-top fluxes. Currently, only the heatflux and salinity flux 
+!> Initialize model-top fluxes. Currently, only the heatflux and salinity flux
 !> can be prescribed, latent flux is zero in this case!
 !------------------------------------------------------------------------------!
-          SUBROUTINE initialize_top( k, j, i, surf, num_h, num_h_kji )       
-
-             IMPLICIT NONE 
+          SUBROUTINE initialize_top( k, j, i, surf, num_h, num_h_kji )
+
+             IMPLICIT NONE
 
              INTEGER(iwp)  ::  i                !< running index x-direction
@@ -2758,5 +2822,5 @@
              ENDIF
 !
-!--          Prescribe latent heat flux at the top      
+!--          Prescribe latent heat flux at the top
              IF ( humidity )  THEN
                 surf%qsws(num_h) = 0.0_wp
@@ -2769,4 +2833,8 @@
                    surf%qrsws(num_h) = 0.0_wp
                 ENDIF
+                IF ( surf_bulk_cloud_model  .AND.  surf_microphysics_ice_extension ) THEN
+                   surf%nisws(num_h) = 0.0_wp
+                   surf%qisws(num_h) = 0.0_wp
+                ENDIF
              ENDIF
 !
@@ -2777,5 +2845,5 @@
 !--          Prescribe top chemical species' flux
              DO  lsp = 1, nvar
-                IF ( air_chemistry  .AND.  constant_top_csflux(lsp) )  THEN 
+                IF ( air_chemistry  .AND.  constant_top_csflux(lsp) )  THEN
                    surf%cssws(lsp,num_h) = top_csflux(lsp) * rho_air_zw(nzt+1)
                 ENDIF
@@ -2796,5 +2864,5 @@
 !--          Increment surface indices
              num_h     = num_h + 1
-             num_h_kji = num_h_kji + 1      
+             num_h_kji = num_h_kji + 1
 
 
@@ -2805,14 +2873,14 @@
 ! Description:
 ! ------------
-!> Initialize vertical surface elements. 
+!> Initialize vertical surface elements.
 !------------------------------------------------------------------------------!
           SUBROUTINE initialize_vertical_surfaces( k, j, i, surf, num_v,       &
                                                    num_v_kji, east_facing,     &
                                                    west_facing, south_facing,  &
-                                                   north_facing )       
-
-             IMPLICIT NONE 
-
-             INTEGER(iwp)  ::  component       !< index of wall_fluxes_ array for respective orientation 
+                                                   north_facing )
+
+             IMPLICIT NONE
+
+             INTEGER(iwp)  ::  component       !< index of wall_fluxes_ array for respective orientation
              INTEGER(iwp)  ::  i               !< running index x-direction
              INTEGER(iwp)  ::  j               !< running index x-direction
@@ -2845,13 +2913,13 @@
              surf%facing(num_v)  = 0
 !
-!--          Surface orientation. Moreover, set component id to map wall_heatflux, 
+!--          Surface orientation. Moreover, set component id to map wall_heatflux,
 !--          etc., on surface type (further below)
              IF ( north_facing )  THEN
-                surf%facing(num_v) = 5 !IBSET( surf%facing(num_v), 0 )  
+                surf%facing(num_v) = 5 !IBSET( surf%facing(num_v), 0 )
                 component          = 4
              ENDIF
 
              IF ( south_facing )  THEN
-                surf%facing(num_v) = 6 !IBSET( surf%facing(num_v), 1 ) 
+                surf%facing(num_v) = 6 !IBSET( surf%facing(num_v), 1 )
                 component          = 3
              ENDIF
@@ -2863,9 +2931,9 @@
 
              IF ( west_facing )  THEN
-                surf%facing(num_v) = 8 !IBSET( surf%facing(num_v), 3 ) 
+                surf%facing(num_v) = 8 !IBSET( surf%facing(num_v), 3 )
                 component          = 1
              ENDIF
 
- 
+
              surf%z0(num_v)  = roughness_length
              surf%z0h(num_v) = z0h_factor * roughness_length
@@ -2894,9 +2962,9 @@
                 surf%qsws(num_v) = wall_humidityflux(component)
 !
-!--             Following wall fluxes are assumed to be zero 
+!--             Following wall fluxes are assumed to be zero
                 IF ( surf_bulk_cloud_model .AND. surf_microphysics_morrison)  THEN
                    surf%qcs(num_v) = 0.0_wp
                    surf%ncs(num_v) = 0.0_wp
-   
+
                    surf%qcsws(num_v) = 0.0_wp
                    surf%ncsws(num_v) = 0.0_wp
@@ -2905,8 +2973,15 @@
                    surf%qrs(num_v) = 0.0_wp
                    surf%nrs(num_v) = 0.0_wp
-   
+
                    surf%qrsws(num_v) = 0.0_wp
                    surf%nrsws(num_v) = 0.0_wp
                 ENDIF
+                IF ( surf_bulk_cloud_model .AND. surf_microphysics_ice_extension)  THEN
+                   surf%qis(num_v) = 0.0_wp
+                   surf%nis(num_v) = 0.0_wp
+
+                   surf%qisws(num_v) = 0.0_wp
+                   surf%nisws(num_v) = 0.0_wp
+                ENDIF
              ENDIF
 
@@ -2916,5 +2991,5 @@
              ENDIF
 
-             IF ( air_chemistry )  THEN        
+             IF ( air_chemistry )  THEN
                 DO  lsp = 1, nvar
                    surf%css(lsp,num_v)   = 0.0_wp
@@ -2924,6 +2999,6 @@
 
 !
-!--          So far, salinityflux at vertical surfaces is simply zero 
-!--          at the moment  
+!--          So far, salinityflux at vertical surfaces is simply zero
+!--          at the moment
              IF ( ocean_mode )  surf%sasws(num_v) = wall_salinityflux(component)
 !
@@ -2945,13 +3020,13 @@
                                                index_space_j                   &
                                              )
-    
+
        INTEGER(iwp) ::  m  !< running index over surface elements
        INTEGER(iwp) ::  ns !< number of surface elements in var_surf
 
        INTEGER(iwp), DIMENSION(1:ns) ::  index_space_i !< grid indices along x direction where surface properties should be defined
-       INTEGER(iwp), DIMENSION(1:ns) ::  index_space_j !< grid indices along y direction where surface properties should be defined 
-       
+       INTEGER(iwp), DIMENSION(1:ns) ::  index_space_j !< grid indices along y direction where surface properties should be defined
+
        REAL(wp) ::  fill_value !< fill value in var_2d
-       
+
        REAL(wp), DIMENSION(1:ns) ::  var_surf !< 1D surface variable that should be initialized
        REAL(wp), DIMENSION(nys:nyn,nxl:nxr) ::  var_2d !< input variable
@@ -2962,5 +3037,5 @@
           ENDIF
        ENDDO
-       
+
     END SUBROUTINE init_single_surface_properties
 
@@ -3019,5 +3094,5 @@
        ENDDO
 !
-!--    In the following, gather data from surfaces elements with the same 
+!--    In the following, gather data from surfaces elements with the same
 !--    facing (but possibly differt type) on 1 data-type array.
        mm(0:2) = 1
@@ -3039,4 +3114,8 @@
                    IF ( ALLOCATED( surf_def_h(l)%ncs ) )                       &
                       surf_h(l)%ncs(mm(l))     = surf_def_h(l)%ncs(m)
+                   IF ( ALLOCATED( surf_def_h(l)%qis ) )                       &
+                      surf_h(l)%qis(mm(l))     = surf_def_h(l)%qis(m)
+                   IF ( ALLOCATED( surf_def_h(l)%nis ) )                       &
+                      surf_h(l)%nis(mm(l))     = surf_def_h(l)%nis(m)
                    IF ( ALLOCATED( surf_def_h(l)%qrs ) )                       &
                       surf_h(l)%qrs(mm(l))     = surf_def_h(l)%qrs(m)
@@ -3050,7 +3129,7 @@
                       surf_h(l)%pt_surface(mm(l)) = surf_def_h(l)%pt_surface(m)
                    IF ( ALLOCATED( surf_def_h(l)%q_surface ) )                 &
-                      surf_h(l)%q_surface(mm(l)) = surf_def_h(l)%q_surface(m) 
+                      surf_h(l)%q_surface(mm(l)) = surf_def_h(l)%q_surface(m)
                    IF ( ALLOCATED( surf_def_h(l)%vpt_surface ) )               &
-                      surf_h(l)%vpt_surface(mm(l)) = surf_def_h(l)%vpt_surface(m)                      
+                      surf_h(l)%vpt_surface(mm(l)) = surf_def_h(l)%vpt_surface(m)
                    IF ( ALLOCATED( surf_def_h(l)%usws ) )                      &
                       surf_h(l)%usws(mm(l))    = surf_def_h(l)%usws(m)
@@ -3063,10 +3142,10 @@
                    IF ( ALLOCATED( surf_def_h(l)%ssws ) )                      &
                       surf_h(l)%ssws(mm(l))    = surf_def_h(l)%ssws(m)
-                   IF ( ALLOCATED( surf_def_h(l)%css ) )  THEN 
+                   IF ( ALLOCATED( surf_def_h(l)%css ) )  THEN
                       DO  lsp = 1,nvar
                          surf_h(l)%css(lsp,mm(l)) = surf_def_h(l)%css(lsp,m)
                       ENDDO
                    ENDIF
-                   IF ( ALLOCATED( surf_def_h(l)%cssws ) )  THEN 
+                   IF ( ALLOCATED( surf_def_h(l)%cssws ) )  THEN
                       DO  lsp = 1,nvar
                          surf_h(l)%cssws(lsp,mm(l)) = surf_def_h(l)%cssws(lsp,m)
@@ -3077,11 +3156,15 @@
                    IF ( ALLOCATED( surf_def_h(l)%qrsws ) )                     &
                       surf_h(l)%qrsws(mm(l))   = surf_def_h(l)%qrsws(m)
+                   IF ( ALLOCATED( surf_def_h(l)%qisws ) )                     &
+                      surf_h(l)%qisws(mm(l))   = surf_def_h(l)%qisws(m)
                    IF ( ALLOCATED( surf_def_h(l)%ncsws ) )                     &
                       surf_h(l)%ncsws(mm(l))   = surf_def_h(l)%ncsws(m)
+                   IF ( ALLOCATED( surf_def_h(l)%nisws ) )                     &
+                      surf_h(l)%nisws(mm(l))   = surf_def_h(l)%nisws(m)
                    IF ( ALLOCATED( surf_def_h(l)%nrsws ) )                     &
                       surf_h(l)%nrsws(mm(l))   = surf_def_h(l)%nrsws(m)
                    IF ( ALLOCATED( surf_def_h(l)%sasws ) )                     &
                       surf_h(l)%sasws(mm(l))   = surf_def_h(l)%sasws(m)
-                
+
                    mm(l) = mm(l) + 1
                 ENDDO
@@ -3102,4 +3185,8 @@
                       IF ( ALLOCATED( surf_lsm_h%ncs ) )                       &
                          surf_h(0)%ncs(mm(0))     = surf_lsm_h%ncs(m)
+                      IF ( ALLOCATED( surf_lsm_h%qis ) )                       &
+                         surf_h(0)%qis(mm(0))     = surf_lsm_h%qis(m)
+                      IF ( ALLOCATED( surf_lsm_h%nis ) )                       &
+                         surf_h(0)%nis(mm(0))     = surf_lsm_h%nis(m)
                       IF ( ALLOCATED( surf_lsm_h%qrs ) )                       &
                          surf_h(0)%qrs(mm(0))     = surf_lsm_h%qrs(m)
@@ -3126,5 +3213,5 @@
                       IF ( ALLOCATED( surf_lsm_h%ssws ) )                      &
                          surf_h(0)%ssws(mm(0))    = surf_lsm_h%ssws(m)
-                      IF ( ALLOCATED( surf_lsm_h%css ) )  THEN                  
+                      IF ( ALLOCATED( surf_lsm_h%css ) )  THEN
                          DO  lsp = 1, nvar
                             surf_h(0)%css(lsp,mm(0)) = surf_lsm_h%css(lsp,m)
@@ -3134,19 +3221,23 @@
                          DO  lsp = 1, nvar
                             surf_h(0)%cssws(lsp,mm(0)) = surf_lsm_h%cssws(lsp,m)
-                         ENDDO 
+                         ENDDO
                       ENDIF
                       IF ( ALLOCATED( surf_lsm_h%qcsws ) )                     &
                          surf_h(0)%qcsws(mm(0))   = surf_lsm_h%qcsws(m)
+                      IF ( ALLOCATED( surf_lsm_h%qisws ) )                     &
+                         surf_h(0)%qisws(mm(0))   = surf_lsm_h%qisws(m)
                       IF ( ALLOCATED( surf_lsm_h%qrsws ) )                     &
                          surf_h(0)%qrsws(mm(0))   = surf_lsm_h%qrsws(m)
                       IF ( ALLOCATED( surf_lsm_h%ncsws ) )                     &
                          surf_h(0)%ncsws(mm(0))   = surf_lsm_h%ncsws(m)
+                      IF ( ALLOCATED( surf_lsm_h%nisws ) )                     &
+                         surf_h(0)%nisws(mm(0))   = surf_lsm_h%nisws(m)
                       IF ( ALLOCATED( surf_lsm_h%nrsws ) )                     &
                          surf_h(0)%nrsws(mm(0))   = surf_lsm_h%nrsws(m)
                       IF ( ALLOCATED( surf_lsm_h%sasws ) )                     &
                         surf_h(0)%sasws(mm(0))   = surf_lsm_h%sasws(m)
-                
+
                       mm(0) = mm(0) + 1
-             
+
                    ENDDO
 
@@ -3165,4 +3256,8 @@
                       IF ( ALLOCATED( surf_usm_h%ncs ) )                       &
                          surf_h(0)%ncs(mm(0))     = surf_usm_h%ncs(m)
+                      IF ( ALLOCATED( surf_usm_h%qis ) )                       &
+                         surf_h(0)%qis(mm(0))     = surf_usm_h%qis(m)
+                      IF ( ALLOCATED( surf_usm_h%nis ) )                       &
+                         surf_h(0)%nis(mm(0))     = surf_usm_h%nis(m)
                       IF ( ALLOCATED( surf_usm_h%qrs ) )                       &
                          surf_h(0)%qrs(mm(0))     = surf_usm_h%qrs(m)
